local class = require("silo.lib.class")
local TaskQueue = class("silo.TaskQueue")

local WORKERS = 8

function TaskQueue:new(ctx)
  self.ctx = ctx
  self.queue = {}

  for n = 1, WORKERS do
    ctx:addTask(function()
      while true do
        if #self.queue > 0 then
          local f = table.remove(self.queue, 1)
          f()
        else
          os.pullEvent()
        end
      end
    end)
  end
end

function TaskQueue:every(n, f)
  local timerId = os.startTimer(n)
  self.ctx.bus:register("event.timer", function(id)
    if id ~= timerId then return end
    timerId = os.startTimer(n)

    f()
  end)
end

function TaskQueue:enqueue(f)
  table.insert(self.queue, f)
end

return TaskQueue
